package cn.exploring.engine.server.db.service;

import cn.exploring.engine.server.db.dao.StudentInfoMapper;
import cn.exploring.engine.server.db.domain.StudentInfo;
import cn.exploring.engine.server.db.domain.StudentInfoExample;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;
import java.time.LocalDateTime;
import java.util.List;

@Service
public class StudentInfoService {

    @Resource
    StudentInfoMapper studentInfoMapper;

    /**
     * 添加
     * @param studentInfo
     * @return
     */
    public Object addStudentInfo(StudentInfo studentInfo) {
        LocalDateTime now = LocalDateTime.now();
        studentInfo.setAddTime(now);
        studentInfo.setUpdateTime(now);
        studentInfoMapper.insertSelective(studentInfo);
        return "添加成功";
    }

    /**
     * 更新数据
     * @param studentInfo
     * @return
     */
    public Object updateStudentInfo(StudentInfo studentInfo) {
        studentInfo.setUpdateTime(LocalDateTime.now());
        studentInfoMapper.updateByPrimaryKey(studentInfo);
        return "修改成功";
    }

    /**
     * 批量删除数据
     * @param idList
     * @return
     */
    public Object batchDeleted(List<Integer> idList) {
        List<StudentInfo> studentInfoList = selectStudentInfo(null, null, idList);
        studentInfoList.forEach(x -> {
            x.setDeleted(false);
            updateStudentInfo(x);
        });
        return "batch deleted  OK";
    }

    /**
     * 检索学生相关的信息
     * @param studentName
     * @param studentId
     * @return
     */
    public List<StudentInfo> selectStudentInfo(String studentName, String studentId, List<Integer> idList) {
        StudentInfoExample example = new StudentInfoExample();
        StudentInfoExample.Criteria criteria = example.createCriteria();
        criteria.andDeletedEqualTo(false);
        if (!StringUtils.isEmpty(studentName)) {
            criteria.andNameLike("%" + studentName + "%");
        }
        if (!StringUtils.isEmpty(studentId)) {
            criteria.andStudentUniqueIdEqualTo(studentId);
        }
        if (idList != null && idList.size() > 0) {
            criteria.andIdIn(idList);
        }
        return studentInfoMapper.selectByExample(example);
    }



}
